Package: RareVariantVis
Type: Package
Title: A suite for analysis of rare genomic variants in whole genome
        sequencing data
Version: 2.40.0
Date: 2018-04-15
Author: Adam Gudys and Tomasz Stokowy
Maintainer: Tomasz Stokowy <tomasz.stokowy@k2.uib.no>
Description: Second version of RareVariantVis package aims to provide comprehensive information about rare variants for your genome data. 
        It annotates, filters and presents genomic variants (especially rare ones) in a global, per
        chromosome way. For discovered rare variants CRISPR guide RNAs are designed, so the user can plan further functional studies. Large structural variants, including copy number variants are also supported. 
        Package accepts variants directly from variant caller - for example GATK or Speedseq. 
        Output of package are lists of variants together with adequate visualization. 
        Visualization of variants is performed in two ways -
        standard that outputs png figures and interactive that uses
        JavaScript d3 package. Interactive visualization allows to
        analyze trio/family data, for example in search for causative
        variants in rare Mendelian diseases, in point-and-click interface. The package includes homozygous region caller and allows to analyse whole human genomes in less than 30 minutes on a desktop computer.
        RareVariantVis disclosed novel causes of several rare monogenic disorders, including one with non-coding causative variant - keratolythic winter erythema.
License: Artistic-2.0
Depends: BiocGenerics, VariantAnnotation, googleVis, GenomicFeatures
Imports: S4Vectors, IRanges, GenomeInfoDb, GenomicRanges, gtools,
        BSgenome, BSgenome.Hsapiens.UCSC.hg19,
        TxDb.Hsapiens.UCSC.hg19.knownGene, phastCons100way.UCSC.hg19,
        SummarizedExperiment, GenomicScores
Suggests: knitr
VignetteBuilder: knitr
biocViews: GenomicVariation, Sequencing, WholeGenome
NeedsCompilation: no
git_url: https://git.bioconductor.org/packages/RareVariantVis
git_branch: RELEASE_3_23
git_last_commit: e79f45f
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
Packaged: 2026-04-29 00:05:22 UTC; biocbuild

.alternate <- function(sequences, alt_allele, ref_width, gsize) {
    paste0(substr(sequences, start = 1, stop = gsize - nchar(alt_allele)),
           alt_allele,
           substring(sequences, first = gsize + ref_width - nchar(alt_allele) + 1))
}

getCrisprGuides <- function(df,
                            genome = BSgenome.Hsapiens.UCSC.hg19::
                                BSgenome.Hsapiens.UCSC.hg19,
                            gsize = 23,
                            PAM = "GG",
                            PAM_rev = "CC") {

    ref_width <- nchar(df$ref_allele)
    alt_width <- nchar(df$alt_allele)

    sequences <- BSgenome::getSeq(
        genome,
        paste0("chr", df$chromosome),
        as.numeric(df$final_positions) - gsize + alt_width,
        as.numeric(df$final_positions) + ref_width + gsize - alt_width - 1,
        as.character = FALSE)

    sequences <- .alternate(sequences, tolower(df$alt_allele), ref_width, gsize)
    PAMs <- gregexpr(pattern = PAM, sequences)
    PAMs <- sapply(PAMs, function(x) x[x > gsize][1])
    guides <- substr(sequences,
                     start = PAMs + nchar(PAM) - gsize,
                     stop = PAMs + nchar(PAM) - 1)

    # for those with NA try the other strand
    PAMs_rev <- gregexpr(pattern = PAM_rev, sequences[is.na(PAMs)])
    PAMs_rev <- sapply(PAMs_rev, function(x) {
        x <- x[x < gsize & x > -1]
        if (length(x) == 0) NA else x[length(x)]
    })

    guides[is.na(PAMs)] <- substr(sequences[is.na(PAMs)],
                                  start = PAMs_rev,
                                  stop = PAMs_rev - nchar(PAM_rev) + gsize + 1)
    guides
}

callHomozygous <- function(
    sample,
    chromosomes,
    caller = "speedseq",
    MA_Window = 1000,
    HMZ_length = 100000,
    min_n_HMZ = 20) {

    sampleName = unlist(strsplit(basename(sample), '[.]'))[1]

    # Annotation files
    centromeres_file    = system.file("extdata", "CentromeresHg19.txt", package =
                                          "RareVariantVis")

    # load annotations
    centromeres = read.delim(centromeres_file,
                             header = TRUE,
                             stringsAsFactors = FALSE)

    dir.create(paste0(getwd(),"/HMZ_Calling_Output_", sampleName))

    # create empty table for output
    output_table = data.frame(
        sample = NA,
        chromosome = "",
        start_positions = NA,
        end_positions = NA,
        length = NA,
        var_in_reg = NA,
        perc_HMZ = NA,
        stringsAsFactors = FALSE
    )


    # begin chromosome loop
    for (chromosome in chromosomes) {
        # determine chromosome index
        if (chromosome == "X") {
            chromosomeIndex = 23
        } else if (chromosome == "Y") {
            chromosomeIndex = 24
        } else {
            chromosomeIndex = as.integer(chromosome)
        }

        ###############################################
        # Part 1 - read 1 chromosome from a genome
        ###############################################

        param = ScanVcfParam(which = GRanges(chromosome, IRanges(1, 250000000)))
        vcf = readVcf(sample, genome = "hg19", param = param)

        if (caller == "speedseq"){
            firstADs = sapply(geno(vcf)[["AO"]], function(m) m[1])
            secondADs = sapply(geno(vcf)[["RO"]], function(m) m[1])
            positions = start(rowRanges(vcf))
            variation = firstADs / (firstADs + secondADs)
        } else {
            firstADs = sapply( geno(vcf)[["AD"]], function(m) m[1] )
            secondADs = sapply( geno(vcf)[["AD"]], function(n) n[2] )
            positions = start(rowRanges(vcf))
            variation = secondADs / (firstADs + secondADs)
        }

        ###############################################
        # Part 2 - Compute and plot
        ###############################################

        setwd(paste0(getwd(),"/HMZ_Calling_Output_", sampleName))

        if (chromosome != "Y") {
            MA <- movingAverage(variation, MA_Window)

            ### HMZ calling

            g075 = MA > 0.75
            g075_xor = NULL

            for (j in 1:length(g075) - 1) {
                g075_xor[j] = xor(g075[j], g075[j + 1])

            }

            starts_hmz = g075[2:length(g075)] & g075_xor
            starts_hmz_up = rep(FALSE, length(starts_hmz) + 1)
            starts_hmz_up[1] = MA[1] > 0.75
            starts_hmz_up[2:length(starts_hmz_up)] = starts_hmz

            stops_hmz = !g075[2:length(g075)] & g075_xor
            stops_hmz_up = rep(FALSE, length(starts_hmz) + 1)
            stops_hmz_up[1:length(stops_hmz)] = stops_hmz
            stops_hmz_up[length(stops_hmz_up)] = MA[(length(MA))] > 0.75

            sel_HMZ = (positions[stops_hmz_up] - positions[starts_hmz_up]) > HMZ_length &
                which(stops_hmz_up) - which(starts_hmz_up) > min_n_HMZ

            ### plotting

            png(
                filename = paste(sampleName, "_chr", chromosome,
                                 ".png", sep = ""),
                bg = "white",
                width = 1600,
                height = 1200,
                units = "px",
                pointsize = 24
            )

            plot(
                positions,
                variation,
                cex = 0.2,
                pch = 16,
                col = "blue",
                cex.lab = 1,
                xlab = paste0("Chromosome_", chromosome),
                ylab = "Number of alternative reads / depth",
                ylim = c(0, 1),
                xlim = c(0, max(positions))
            )

            lines(positions, MA, col = "red", lwd = 2)

            abline(h = 0.75, lwd = 4, col = "red")
            abline(v = centromeres$Start[chromosomeIndex],
                   lwd = 4,
                   col = "orange")
            abline(v = centromeres$Stop[chromosomeIndex],
                   lwd = 4,
                   col = "orange")

            abline(v = positions[starts_hmz_up][sel_HMZ],
                   lwd = 1,
                   col = "green")
            abline(v = positions[stops_hmz_up][sel_HMZ],
                   lwd = 1,
                   col = "red")

            dev.off()

        } else {
            png(
                filename = paste(sampleName, "_chr", chromosome,
                                 ".png", sep = ""),
                bg = "white",
                width = 1600,
                height = 1200,
                units = "px",
                pointsize = 24
            )

            plot(
                positions,
                variation,
                cex = 0.2,
                pch = 16,
                col = "blue",
                cex.lab = 1,
                xlab = paste0("Chromosome_", chromosome),
                ylab = "Number of alternative reads / depth",
                ylim = c(0, 1),
                xlim = c(0, max(positions))
            )

            abline(h = 0.75, lwd = 4, col = "red")
            abline(v = centromeres$Start[chromosomeIndex],
                   lwd = 4,
                   col = "orange")
            abline(v = centromeres$Stop[chromosomeIndex],
                   lwd = 4,
                   col = "orange")

            dev.off()
        }

        ###############################################
        # Part 3 - Report
        ###############################################

        if (length(positions[starts_hmz_up][sel_HMZ]) > 0) {
            perc_HMZ = NULL

            if (chromosome != "Y") {
                for (p in 1:length(positions[starts_hmz_up][sel_HMZ])) {
                    variation_curr_hmz = variation[which(starts_hmz_up)[sel_HMZ][p]:which(stops_hmz_up)[sel_HMZ][p]]
                    perc_HMZ[p] = sum(variation_curr_hmz > 0.75) / length(variation_curr_hmz)
                }
            } else {
                perc_HMZ = NA
            }

            current_table = cbind(
                rep(sampleName, length(positions[starts_hmz_up][sel_HMZ])),
                rep(chromosome, length(positions[starts_hmz_up][sel_HMZ])),
                positions[starts_hmz_up][sel_HMZ],
                positions[stops_hmz_up][sel_HMZ],
                positions[stops_hmz_up][sel_HMZ] - positions[starts_hmz_up][sel_HMZ],
                (which(stops_hmz_up) - which(starts_hmz_up))[sel_HMZ],
                round(perc_HMZ, 4) * 100
            )
            colnames(current_table) = colnames(output_table)


            output_table = rbind(output_table, current_table)
        }

    }

    final_table = output_table[!is.na(output_table$start_positions), ]

    write.table(
        final_table,
        paste0("Regions_HMZ_", sampleName, ".txt"),
        sep = "\t",
        row.names = FALSE,
        quote = FALSE
    )

}

movingAverage <- function(x, n=1, centered=FALSE) {

    # Function for moving average was adapted from Cookbook for R website by Winston Chang
    # http://www.cookbook-r.com/Manipulating_data/Calculating_a_moving_average/

    if (centered) {
        before <- floor  ((n-1)/2)
        after  <- ceiling((n-1)/2)
    } else {
        before <- n-1
        after  <- 0
    }

    # Track the sum and count of number of non-NA items
    s     <- rep(0, length(x))
    count <- rep(0, length(x))

    # Add the centered data
    new <- x
    # Add to count list wherever there isn't a
    count <- count + !is.na(new)
    # Now replace NA_s with 0_s and add to total
    new[is.na(new)] <- 0
    s <- s + new

    # Add the data from before
    i <- 1
    while (i <= before) {
        # This is the vector with offset values to add
        new   <- c(rep(NA, i), x[1:(length(x)-i)])

        count <- count + !is.na(new)
        new[is.na(new)] <- 0
        s <- s + new

        i <- i+1
    }

    # Add the data from after
    i <- 1
    while (i <= after) {
        # This is the vector with offset values to add
        new   <- c(x[(i+1):length(x)], rep(NA, i))

        count <- count + !is.na(new)
        new[is.na(new)] <- 0
        s <- s + new

        i <- i+1
    }

    # return sum divided by count
    s/count
}

multipleVis <- function(inputFiles, outputFile, sampleNames, chromosome) {

    for (i in 1:length(inputFiles)) {
        rareVariantVis(inputFiles[i], outputFile, sampleNames[i], c(chromosome), (i > 1))
    }
}

rareVariantVis <- function(input, outputFile, sample, chromosomes = c(as.character(1:22), "X", "Y"), append = FALSE) {

    centromeres_file    = system.file("extdata", "CentromeresHg19.txt", package = "RareVariantVis")
    centromeres = read.delim(centromeres_file,
                             header = TRUE,
                             stringsAsFactors = FALSE)

    cat("Reading input:", input, "...")

    if (is.character(input)){
        entireTable <- read.table(input, header = TRUE, sep="\t", quote="\"", fill = TRUE, stringsAsFactors = FALSE)
    } else {
        entireTable = input
    }

    scatter = list()
    scatterId = 1

    cat("done!\n")
    # iterate over all chromosomes
    for (cid in 1:length(chromosomes)) {
        # get subtable corresponding to current chromosome
        chromosome = chromosomes[cid]

        if (chromosome == "X") {
            chromosomeIndex = 23
        } else if (chromosome == "Y") {
            chromosomeIndex = 24
        } else {
            chromosomeIndex = as.integer(chromosome)
        }

        table = entireTable[entireTable$chromosome == chromosome,]

        if (nrow(table) > 0) {
            variationRound = round(table$final_variations, 2)
            data = as.data.frame(cbind(table$final_positions, table$final_variations))
            data$Gene.name = paste("Gene: ", as.character(table$gene_name),
                                   "<br>Position: ", table$final_positions,
                                   "<br>Alt/Depth: ", variationRound, sep="")

            colnames(data) = c("Start.position", paste("Sample: ", sample, sep = ""),
                               paste("Sample: ", sample, ".html.tooltip", sep = ""))

            scatter[[scatterId]] = gvisScatterChart(data,
                        options=list(
                        title=paste("Sample: ", sample, ", chromosome: ", chromosome, sep = ""),
                        explorer="{actions: ['dragToZoom',
                        'rightClickToReset'],
                        maxZoomIn:0.05}",
                        #chartArea="{width:'85%',height:'80%'}",
                        tooltip="{isHtml:'True'}",
                        series="[{color: 'green', targetAxisIndex: 0},
                        {targetAxisIndex:1}]",
                        crosshair="{trigger:'both'}",
                        legend="none", lineWidth=0, pointSize=8,
                        vAxis="{title:'Number of alternative reads / depth',
                        viewWindow:{min:0, max:1}}",
                        hAxis=paste("{title:'Position on chromosome', viewWindow:{min:0, max:", centromeres$WinSize[chromosomeIndex] ,"}}", sep = ""),
                        #hAxis="{title:'Position on chromosome'}",
                        width=1500, height=200))

            localAppend = append
            if (scatterId > 1) {
                localAppend = TRUE
            }
            cat(scatter[[scatterId]]$html$chart , file=paste(outputFile, sep = ""), append=localAppend)

            scatterId = scatterId + 1;

        }
    }

    cat("Visualisation saved to:", outputFile, '\n')

}

## ----mychunk1, cache=TRUE, eval=FALSE, hide=TRUE------------------------------
# library(RareVariantVis)
# library(DataRareVariantVis)

## ----mychunk2, cache=TRUE, eval=FALSE, hide=TRUE------------------------------
# sample = system.file("extdata", "CoriellIndex_S1.vcf.gz",
#     package = "DataRareVariantVis")
# sv_sample = system.file("extdata", "CoriellIndex_S1.sv.vcf.gz",
#     package = "DataRareVariantVis")

## ----mychunk3, cache=TRUE, eval=FALSE, hide=TRUE------------------------------
# chromosomeVis(sample=sample, sv_sample=sv_sample,
#     chromosomes=c("19"))

## ----mychunk4, cache=TRUE, eval=FALSE, hide=TRUE------------------------------
# rareVariantVis("RareVariants_CoriellIndex_S1.txt",
#                "RareVariants_CoriellIndex_S1.html",
#                "CorielIndex")

## ----mychunk5, cache=TRUE, eval=FALSE, hide=TRUE------------------------------
# inputFiles = c("RareVariants_CoriellIndex_S1.txt",
#                "RareVariants_Coriell_S2.txt")
# sampleNames = c("CoriellIndex_S1", "Coriell_S2");
# multipleVis(inputFiles, "CorielSamples.html", sampleNames, "19")

chromosomeVis <- function(
    sample,
    sv_sample,
    dbSNP_file,
    Exac_file,
    chromosomes,
    pngWidth = 1600,
    pngHeight = 1200,
    caller = "speedseq",
    MA_Window = 1000,
    coding_regions_file = system.file("extdata", "nexterarapidcapture_exome_targetedregions_v1.2_chr19_9-10.bed",
       package = "RareVariantVis"),
    annotation_file = system.file("extdata", "UCSC_hg19_chr9_9-10_refSeq_160702.txt",
       package = "RareVariantVis"),
    uniprot_file = system.file("extdata", "uniprot-all_chr19_9-10.txt",
       package = "RareVariantVis")
    ) {


    sampleName = unlist(strsplit(basename(sample), '[.]'))[1]

    if (missing(dbSNP_file)) {
        dbSNP_file = system.file("extdata", "All_20160601_chr19_9-10.vcf.recode.vcf.gz", package =
                                          "RareVariantVis")
    }

    if (missing(Exac_file)) {
        Exac_file = system.file("extdata", "ExAC.r0.3.1.sites.vep_chr19_9-10.vcf.recode.vcf.gz", package =
                                          "RareVariantVis")
    }

    ###############################################
    # Part 0 - prepare adnnotations
    ###############################################

    # Centromeres for hg19

    url = "http://hgdownload.cse.ucsc.edu/goldenPath/hg19/database/cytoBand.txt.gz"
    cytobands = read.delim(
        text=readLines(gzcon(url(url))),
        header=FALSE, sep="\t", stringsAsFactors = FALSE
    )

    cytobands_acen = cytobands[cytobands$V5 == "acen",]
    cytobands_chr = cytobands_acen[1:dim(cytobands_acen)[1] %% 2 == 1,]
    cytobands_start = cytobands_acen[1:dim(cytobands_acen)[1] %% 2 == 1,]$V2
    cytobands_end =  cytobands_acen[1:dim(cytobands_acen)[1] %% 2 == 0,]$V3
    cytobands_summary = cbind.data.frame(as.character(cytobands_chr$V1),
                                         cytobands_start, cytobands_end, stringsAsFactors = FALSE)

    colnames(cytobands_summary) = c("Chrom", "Start", "Stop")

    url = "http://hgdownload.cse.ucsc.edu/goldenPath/hg19/database/chromInfo.txt.gz"
    chromosome_lengths = read.delim(
        text=readLines(gzcon(url(url))),
        header=FALSE, sep="\t", stringsAsFactors = FALSE
    )

    chr_lengths = cbind(chromosome_lengths[1:24,1:2],
                        ceiling(chromosome_lengths[1:24,2] / 10000000) * 10000000)
    colnames(chr_lengths) = c("Chrom", "ChromLen", "WinSize")

    temp_centromeres = merge(cytobands_summary, chr_lengths, by = "Chrom")

    order_rows_centromeres = match(c(1:22, "X", "Y"), substr(temp_centromeres$Chrom, 4,
                                                             nchar(as.character(temp_centromeres$Chrom))))

    centromeres = temp_centromeres[order_rows_centromeres,]

    # End of centromeres preparation



    # Annotation files
    # centromeres_file    = system.file("extdata", "CentromeresHg19.txt", package =
    #                                          "RareVariantVis")
    # coding_regions_file = system.file("extdata",
    #                                  "nexterarapidcapture_exome_targetedregions_v1.2_chr19_9-10.bed",
    #                                  package = "RareVariantVis")
    # annotation_file     = system.file("extdata", "UCSC_hg19_chr9_9-10_refSeq_160702.txt", package =
    #                                      "RareVariantVis")
    # uniprot_file        = system.file("extdata", "uniprot-all_chr19_9-10.txt", package =
    #                                      "RareVariantVis")
    # load annotations
    # centromeres = read.delim(centromeres_file,
    #                             header = TRUE,
    #                             stringsAsFactors = FALSE)
    anno_whole = read.delim(annotation_file,
                            header = TRUE,
                            stringsAsFactors = FALSE)
    uniprot = read.delim(uniprot_file,
                         header = TRUE,
                         stringsAsFactors = FALSE)
    exome = read.delim(coding_regions_file,
                       header = FALSE,
                       stringsAsFactors = FALSE)

    # create table with empty row (to make binding work properly)
    final_table = data.frame(
        chromosome = "",
        final_positions = NA,
        variant_type = "",
        ref_allele = "",
        alt_allele = "",
        final_variations = NA,
        conservation = NA,
        gene_name = "",
        in_exon = NA,
        stringsAsFactors = FALSE
    )

    final_table = cbind(final_table, uniprot[1, ])

    sv_table = data.frame(
        chromosome = "",
        start_position = NA,
        ID = "",
        REF = "",
        ALT = "",
        QUAL = NA,
        SVTYPE = "",
        GT = "",
        end_position = NA,
        gene_name = "",
        in_exon = NA,
        stringsAsFactors = FALSE
    )

    sv_table = cbind(sv_table, uniprot[1, ])

    complex_table = data.frame(
        chromosome = "",
        start_position = NA,
        gene_name = "",
        in_exon = NA,
        stringsAsFactors = FALSE
    )

    complex_table = cbind(complex_table, uniprot[1, ])

    # begin chromosome loop
    for (chromosome in chromosomes) {
        # determine chromosome index
        if (chromosome == "X") {
            chromosomeIndex = 23
        } else if (chromosome == "Y") {
            chromosomeIndex = 24
        } else {
            chromosomeIndex = as.integer(chromosome)
        }

        ###############################################
        # Part 1 - read 1 chromosome from a genome
        ###############################################

        param = ScanVcfParam(which = GRanges(chromosome, IRanges(1, 250000000)))
        vcf = readVcf(sample, genome = "hg19", param = param)

        if (caller == "speedseq"){
            firstADs = sapply(geno(vcf)[["AO"]], function(m) m[1])
            secondADs = sapply(geno(vcf)[["RO"]], function(m) m[1])
            positions = start(rowRanges(vcf))
            variation = firstADs / (firstADs + secondADs)
        } else {
            firstADs = sapply( geno(vcf)[["AD"]], function(m) m[1] )
            secondADs = sapply( geno(vcf)[["AD"]], function(n) n[2] )
            positions = start(rowRanges(vcf))
            variation = secondADs / (firstADs + secondADs)
        }

        ###############################################
        # Part 2 - Select coding variants
        ###############################################

        # check for proper chromosome
        chr_select = which(exome[, 1] == paste0("chr", chromosome))

        # binary interval search
        lo = exome$V2[chr_select]

        hi = exome$V3[chr_select]

        # find overlapping ranges
        overlapping = vector(mode = "numeric", length = 0)
        if (length(lo) >= 2) {
            for (i in 2:length(lo)) {
                if (hi[i - 1] >= lo[i]) {
                    overlapping = c(overlapping, i)

                }
            }
        }

        # remove boundaries corresponding to overlapping ranges
        if (length(overlapping) > 0) {
            lo = lo[-overlapping] - 0.1 	# 0.1 is to handle properly boundary values
            hi = hi[-(overlapping - 1)] + 0.1
        }

        coding_ranges = c(rbind(lo, hi))
        # interleaved vector of low and high exon borders

        coding_sel = findInterval(positions, coding_ranges)

        # odd indices correspond to positions inside intervals
        coding_sel = c(0, which(coding_sel %% 2 == 1))

        coding_pos = positions[coding_sel]
        coding_var = variation[coding_sel]

        ###############################################
        # Part 3 - Select rare dbSNP variants
        ###############################################

        # beware of strange CAF format!
        param2 = ScanVcfParam(which = GRanges(
            chromosome,
            IRanges(start = coding_pos, end = coding_pos)
        ))
        vcf2 = readVcf(dbSNP_file, genome = "hg19", param = param2)

        # binary interval search
        lo_vcf2 = start(rowRanges(vcf2))
        hi_vcf2 = end(rowRanges(vcf2))

        # find overlapping ranges to identify complex variants
        overlapping_vcf2 = vector(mode = "numeric", length = 0)
        if (length(lo_vcf2) >= 2) {
            for (i in 2:length(lo_vcf2)) {
                if (hi_vcf2[i - 1] >= lo_vcf2[i]) {
                    overlapping_vcf2 = c(overlapping_vcf2, i)

                }
            }
        }

        # indexes of starting records for new coding positions
        first_codpos_ind = setdiff(1:length(lo_vcf2), overlapping_vcf2)

        # simple and complex variants in dbSNP
        prev_present_ind = first_codpos_ind - 1
        simple_variants_dbsnp_ind = intersect(first_codpos_ind, prev_present_ind)

        # positions of simple and complex variants
        simple_variant_positions = lo_vcf2[simple_variants_dbsnp_ind]
        complex_variant_positions = coding_pos[which(is.na(match(
            coding_pos, simple_variant_positions
        )))]

        # handle allelic frequencies
        CAF_array = matrix(NA,
                           nrow = length(simple_variant_positions),
                           ncol = 30)
        rareDBsnp = rep(TRUE, length(simple_variant_positions))

        # check if we found anything
        if (length(simple_variant_positions) > 0) {
            for (i in 1:length(simple_variant_positions)) {
                currentCAF = unlist(info(vcf2)[["CAF"]][simple_variants_dbsnp_ind][i])

                if (length(currentCAF) > 0) {
                    CAF_array[i, 1:length(currentCAF)] = currentCAF
                }

                if (any(currentCAF == ".")) {
                    rareDBsnp[i] = TRUE
                } else {
                    rareDBsnp[i] = !all(as.numeric(currentCAF) > 0.01)
                }
            }

            rareDBsnp_with_complex_pos = sort(c(
                simple_variant_positions[rareDBsnp],
                complex_variant_positions
            ))
            rareDBsnp_with_complex_var = variation[match(rareDBsnp_with_complex_pos, positions)]

            ###############################################
            # Part 4 - Select rare Exac variants
            ###############################################

            # beware of strange AF format!
            param3 = ScanVcfParam(which = GRanges(
                chromosome,
                IRanges(start = rareDBsnp_with_complex_pos, end = rareDBsnp_with_complex_pos)
            ))
            vcf3 = readVcf(Exac_file, genome = "hg19", param = param3)

            # binary interval search
            lo_vcf3 = start(rowRanges(vcf3))
            hi_vcf3 = end(rowRanges(vcf3))

            # find overlapping ranges to identify complex variants
            overlapping_vcf3 = vector(mode = "numeric", length = 0)
            if (length(lo_vcf3) >= 2) {
                for (i in 2:length(lo_vcf3)) {
                    if (hi_vcf3[i - 1] >= lo_vcf3[i]) {
                        overlapping_vcf3 = c(overlapping_vcf3, i)

                    }
                }
            }

            # indexes of starting records for new coding positions
            first_codpos_ind_exac = setdiff(1:length(lo_vcf3), overlapping_vcf3)

            # simple and complex variants in dbSNP
            prev_present_ind_exac = first_codpos_ind_exac - 1
            simple_variants_dbsnp_ind_exac = intersect(first_codpos_ind_exac, prev_present_ind_exac)

            # positions of simple and complex variants
            simple_variant_positions_exac = lo_vcf3[simple_variants_dbsnp_ind_exac]
            complex_variant_positions_exac = rareDBsnp_with_complex_pos[which(is.na(
                match(
                    rareDBsnp_with_complex_pos,
                    simple_variant_positions_exac
                )
            ))]

            # handle allelic frequencies
            Exac_AF_array = matrix(NA,
                                   nrow = length(simple_variant_positions_exac),
                                   ncol = 30)
            rareExac = rep(TRUE, length(simple_variant_positions_exac))
            multipleAltVariant = rep(FALSE, length(simple_variant_positions_exac))

            for (i in 1:length(simple_variant_positions_exac)) {
                currentAF_exac = unlist(info(vcf3)[["AF"]][simple_variants_dbsnp_ind_exac][i])

                if (length(currentAF_exac) > 1) {
                    rareExac[i] = TRUE
                    multipleAltVariant[i] = TRUE
                }
                else if (length(currentAF_exac) < 1) {
                    rareExac[i] = TRUE
                    multipleAltVariant[i] = FALSE
                }
                else{
                    rareExac[i] = currentAF_exac < 0.01
                    multipleAltVariant[i] = FALSE
                }
            }

            # Exac filtering Summary
            # one variant in position and one alternative allele
            simple_nexac_positions = simple_variant_positions_exac[rareExac &
                                                                       !multipleAltVariant]
            simple_nexac_variation = variation[match(simple_nexac_positions, positions)]

            # one variant in position and many alternative alleles
            complex1_exac_positions = simple_variant_positions_exac[rareExac &
                                                                        multipleAltVariant]
            # many variants in one position
            complex2_exac_positions = complex_variant_positions_exac

            complex_positions = sort(c(complex1_exac_positions, complex2_exac_positions))

            ###############################################
            # Part 5 - Predict non-synonymous
            ###############################################

            txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene

            if(length(simple_nexac_positions) > 0){
                param4 = ScanVcfParam(which = GRanges(
                    chromosome,
                    IRanges(start = simple_nexac_positions, end = simple_nexac_positions)
                ))
                vcf4 = readVcf(sample, genome = "hg19", param = param4)

                if(caller == "GATK"){
                    seqlevels(vcf4) = chromosome
                }

                vcf4 <- renameSeqlevels(vcf4, paste0("chr", chromosome))
                synonymous <- predictCoding(vcf4, txdb, Hsapiens)

                UniqueNonsyn = unique(synonymous[mcols(synonymous)$CONSEQUENCE == "nonsynonymous"])
                UniqueFrames = unique(synonymous[mcols(synonymous)$CONSEQUENCE == "frameshift"])
                UniqueNonsen = unique(synonymous[mcols(synonymous)$CONSEQUENCE == "nonsense"])

                RareNonsynCoding = c(UniqueNonsyn, UniqueFrames, UniqueNonsen)

                final_positions = sort(start(ranges(RareNonsynCoding)))
                final_variations = variation[match(final_positions, positions)]
            } else {
                final_positions = NULL
                final_variations = NULL
            }

            ###############################################
            # Part 6 - Annotate selected and report
            ###############################################

            # filter annotations by chromosome,
            anno = anno_whole[anno_whole$chrom == paste0("chr", chromosome),]

            # find genes containing analysed positions
            ordering_start = order(anno$txStart)
            ordering_end = order(anno$txEnd)
            intervals_start = findInterval(final_positions, anno$txStart[ordering_start])

            intervals_end = findInterval(final_positions, anno$txEnd[ordering_end])

            if (length(final_positions) > 0) {
                # get conservation scores
                conservations =  score(phastCons100way.UCSC.hg19,
                                        GRanges(
                                            seqnames = paste0("chr", chromosome) ,
                                            IRanges(start = final_positions, width = 1)
                                        ))

                # analyse all positions
                for (i in 1:length(final_positions)) {
                    row_left = list(
                        chromosome,
                        final_positions[i],
                        as.character(mcols(RareNonsynCoding)$CONSEQUENCE[match(final_positions[i],
                                                                               start(RareNonsynCoding))]),
                        as.character(mcols(RareNonsynCoding)$REF[match(final_positions[i],
                                                                       start(RareNonsynCoding))]),
                        as.character(unlist(
                            mcols(RareNonsynCoding)$ALT
                        ))[match(final_positions[i],
                                 start(RareNonsynCoding))],
                        final_variations[i],
                        conservations[i]
                    )

                    starting_before = ordering_start[1:intervals_start[i]]
                    ending_after = ordering_end[(intervals_end[i] + 1):length(ordering_end)]
                    common = intersect(starting_before, ending_after)

                    # proceed only when position intersects with some gene
                    if (length(common) > 0) {
                        uniqueMask = !duplicated(anno[common,]$name2)

                        uniqueCommon = common[uniqueMask]

                        # for all genes containing the position
                        for (ig in 1:length(uniqueCommon)) {
                            # extract gene name
                            gene_id = uniqueCommon[ig]

                            gene = anno$name2[gene_id]

                            exon_starts = as.numeric(unlist(
                                strsplit(anno$exonStarts[gene_id], split = ",")
                            ))
                            exon_ends = as.numeric(unlist(
                                strsplit(anno$exonEnds[gene_id], split = ",")
                            ))

                            gene_ranges = c(rbind(exon_starts, exon_ends)) # interleaved vector of low and high exon borders
                            interval = findInterval(final_positions[i], gene_ranges)

                            exon = (interval %% 2 == 1)
                            uniprot_row = uniprot[which(uniprot$Gene.names...primary.. == anno[uniqueCommon[ig], ]$name2),]

                            if (dim(uniprot_row)[1] == 0) {
                                uniprot_row = rep(NA, 11)
                            }

                            row = c(row_left, gene, exon, uniprot_row)
                            final_table = rbind(final_table, unlist(row))
                        }
                    } else {
                        row = c(row_left, rep(NA, 13))
                        final_table = rbind(final_table, row)
                    }

                } # end position loop


                ###############################################
                # Part 6b - complex variants
                ###############################################

                # find genes containing analysed positions
                intervals_start = findInterval(complex_positions, anno$txStart[ordering_start])
                intervals_end = findInterval(complex_positions, anno$txEnd[ordering_end])

                if (length(complex_positions) > 0) {

                    # analyse all positions
                    for (i in 1:length(complex_positions)) {
                        row_left = list(
                            chromosome,
                            complex_positions[i]
                        )

                        starting_before = ordering_start[1:intervals_start[i]]
                        ending_after = ordering_end[(intervals_end[i] + 1):length(ordering_end)]
                        common = intersect(starting_before, ending_after)

                        # proceed only when position intersects with some gene
                        if (length(common) > 0) {
                            uniqueMask = !duplicated(anno[common,]$name2)

                            uniqueCommon = common[uniqueMask]

                            # for all genes containing the position
                            for (ig in 1:length(uniqueCommon)) {
                                # extract gene name
                                gene_id = uniqueCommon[ig]

                                gene = anno$name2[gene_id]

                                exon_starts = as.numeric(unlist(
                                    strsplit(anno$exonStarts[gene_id], split = ",")
                                ))
                                exon_ends = as.numeric(unlist(
                                    strsplit(anno$exonEnds[gene_id], split = ",")
                                ))

                                gene_ranges = c(rbind(exon_starts, exon_ends)) # interleaved vector of low and high exon borders
                                interval = findInterval(complex_positions[i], gene_ranges)

                                exon = (interval %% 2 == 1)
                                uniprot_row = uniprot[which(uniprot$Gene.names...primary.. == anno[uniqueCommon[ig], ]$name2),]

                                if (dim(uniprot_row)[1] == 0) {
                                    uniprot_row = rep(NA, 11)
                                }

                                row = c(row_left, gene, exon, uniprot_row)
                                complex_table = rbind(complex_table, unlist(row))
                            }
                        } else {
                            row = c(row_left, rep(NA, 13))
                            complex_table = rbind(complex_table, row)
                        }

                    } # end position loop
                }
            }
        }

        ###############################################
        # Part 7 - Load and filter structural variants
        ###############################################

        if (!missing(sv_sample)) {

            sv_local_table = read.table(
                text = "",
                col.names = colnames(sv_table),
                colClasses = sapply(sv_table, class)
            )

            param = ScanVcfParam(which = GRanges(chromosome, IRanges(1, 250000000)))
            vcf_sv = readVcf(sv_sample, genome = "hg19", param = param)

            dupdel_variant_mask = (info(vcf_sv)[["SVTYPE"]] == "DUP") |
                (info(vcf_sv)[["SVTYPE"]] == "DEL")
            point_variant_mask = info(vcf_sv)[["SVTYPE"]] == "BND"

            dupdel_variant_positions_all = start(rowRanges(vcf_sv[dupdel_variant_mask]))
            dupdel_variant_ends_all = info(vcf_sv[dupdel_variant_mask])[["END"]]

            point_variant_positions_all = start(rowRanges(vcf_sv[point_variant_mask]))

            fitv_begins = findInterval(dupdel_variant_positions_all, coding_ranges)
            fitv_ends = findInterval(dupdel_variant_ends_all, coding_ranges)

            dupdel_variant_sel = which((fitv_begins %% 2 == 1) |
                                           # variant begins inside coding region
                                           (fitv_ends %% 2 == 1) | # variant ends inside coding region
                                           (fitv_ends - fitv_begins >= 1)) # variant spans over multiple intervals

            dupdel_variant_positions = dupdel_variant_positions_all[dupdel_variant_sel]
            dupdel_variant_ends = dupdel_variant_ends_all[dupdel_variant_sel]

            point_variant_sel = which(findInterval(point_variant_positions_all, coding_ranges) %% 2 == 1)
            point_variant_positions = point_variant_positions_all[point_variant_sel]

            matched_dupdel = match(dupdel_variant_positions, start(rowRanges(vcf_sv)))
            matched_point = match(point_variant_positions, start(rowRanges(vcf_sv)))

            ###############################################
            # Part 8 - Annotate duplications/deletions
            ###############################################

            # find genes containing analysed positions
            ordering_start = order(anno$txStart)
            ordering_end = order(anno$txEnd)

            if (length(dupdel_variant_positions)) {
                variantStart.geneStart = findInterval(dupdel_variant_positions, anno$txStart[ordering_start])

                variantStart.geneEnd = findInterval(dupdel_variant_positions, anno$txEnd[ordering_end])


                variantEnd.geneStart = findInterval(dupdel_variant_ends, anno$txStart[ordering_start])

                variantEnd.geneEnd = findInterval(dupdel_variant_ends, anno$txEnd[ordering_end])


                # analyse begining positions of duplications/deletions
                for (i in 1:length(dupdel_variant_positions)) {
                    row_left = list(
                        chromosome,
                        start(vcf_sv[matched_dupdel])[i],
                        rownames(vcf_sv[matched_dupdel])[i],
                        "N",
                        unlist(rowRanges(vcf_sv)$ALT)[matched_dupdel][i],
                        unlist(rowRanges(vcf_sv)$QUAL)[matched_dupdel][i],
                        info(vcf_sv)$SVTYPE[matched_dupdel][i],
                        geno(vcf_sv)$GT[matched_dupdel][i],
                        info(vcf_sv)$END[matched_dupdel][i]
                    )

                    # genes overlapping with variant:
                    # - start before variant end
                    # - end after variant begin
                    startingBeforeVariantEnd = ordering_start[1:variantStart.geneStart[i]]
                    endingAfterVariantStart = ordering_end[(variantStart.geneEnd[i] +
                                                                1):length(ordering_end)]
                    overlappingGenes = intersect(startingBeforeVariantEnd,
                                                 endingAfterVariantStart)


                    # proceed only when position intersects with some gene
                    if (length(overlappingGenes) > 0) {
                        uniqueMask = !duplicated(anno[overlappingGenes,]$name2)

                        uniqueCommon = overlappingGenes[uniqueMask]

                        # for all genes containing the position
                        for (ig in 1:length(uniqueCommon)) {
                            # extract gene name
                            gene_id = uniqueCommon[ig]

                            gene = anno$name2[gene_id]

                            exon_starts = as.numeric(unlist(
                                strsplit(anno$exonStarts[gene_id], split = ",")
                            ))
                            exon_ends = as.numeric(unlist(strsplit(
                                anno$exonEnds[gene_id], split = ","
                            )))

                            # interleaved vector of low and high exon borders
                            gene_ranges = c(rbind(exon_starts, exon_ends))
                            variantBegin.interval = findInterval(dupdel_variant_positions[i],
                                                                 gene_ranges)
                            variantEnd.interval = findInterval(dupdel_variant_ends[i], gene_ranges)

                            in_exon = ((variantBegin.interval %% 2 == 1) |
                                           (variantEnd.interval %% 2 == 1) |
                                           (
                                               variantEnd.interval - variantBegin.interval
                                           ) >= 1
                            )
                            uniprot_row = uniprot[which(uniprot$Gene.names...primary.. == anno[uniqueCommon[ig], ]$name2),]

                            if (dim(uniprot_row)[1] == 0) {
                                uniprot_row = rep(NA, 11)
                            }

                            row = c(row_left, gene, in_exon, uniprot_row)
                        }
                    } else {
                        row = c(row_left, rep(NA, 13))
                    }

                    #instead of rbind which messes row names for empty frames
                    sv_local_table[nrow(sv_local_table) + 1, ] = row
                } # end position loop
            }

            ###############################################
            # Part 9 - Annotate point structural variants
            ###############################################

            if (length(point_variant_positions) > 0) {
                # find genes containing analysed positions
                intervals_start = findInterval(point_variant_positions, anno$txStart[ordering_start])

                intervals_end = findInterval(point_variant_positions, anno$txEnd[ordering_end])

                # analyse begining/ending positions of duplications/deletions
                for (i in 1:length(point_variant_positions)) {
                    row_left = list(
                        chromosome,
                        start(vcf_sv[matched_point])[i],
                        rownames(vcf_sv[matched_point])[i],
                        "N",
                        unlist(rowRanges(vcf_sv)$ALT)[matched_point][i],
                        unlist(rowRanges(vcf_sv)$QUAL)[matched_point][i],
                        info(vcf_sv)$SVTYPE[matched_point][i],
                        geno(vcf_sv)$GT[matched_point][i],
                        info(vcf_sv)$END[matched_point][i]
                    )

                    # consider variant begin positions
                    starting_before = ordering_start[1:intervals_start[i]]
                    ending_after = ordering_end[(intervals_end[i] + 1):length(ordering_end)]
                    common = intersect(starting_before, ending_after)

                    # proceed only when position intersects with some gene
                    if (length(common) > 0) {
                        uniqueMask = !duplicated(anno[common,]$name2)

                        uniqueCommon = common[uniqueMask]

                        # for all genes containing the position
                        for (ig in 1:length(uniqueCommon)) {
                            # extract gene name
                            gene_id = uniqueCommon[ig]

                            gene = anno$name2[gene_id]

                            exon_starts = as.numeric(unlist(
                                strsplit(anno$exonStarts[gene_id], split = ",")
                            ))
                            exon_ends = as.numeric(unlist(strsplit(
                                anno$exonEnds[gene_id], split = ","
                            )))

                            # interleaved vector of low and high exon borders
                            gene_ranges = c(rbind(exon_starts, exon_ends))
                            interval = findInterval(point_variant_positions[i],
                                                    gene_ranges)

                            exon = (interval %% 2 == 1)
                            uniprot_row = uniprot[which(uniprot$Gene.names...primary.. == anno[uniqueCommon[ig], ]$name2),]

                            if (dim(uniprot_row)[1] == 0) {
                                uniprot_row = rep(NA, 11)
                            }

                            row = c(row_left, gene, exon, uniprot_row)
                        }
                    } else {
                        row = c(row_left, rep(NA, 13))
                    }

                    #instead of rbind which messes row names for empty frames
                    sv_local_table[nrow(sv_local_table) + 1, ] = row

                } # end position loop
            }

            sv_local_table = sv_local_table[order(as.numeric(sv_local_table[, 2])), ]
            sv_local_table = sv_local_table[sv_local_table$QUAL > 0, ]

            variation_sv = rep(0, length(sv_local_table$start_position))
            variation_sv[sv_local_table$GT == "0/1"] = 0.5
            variation_sv[sv_local_table$GT == "1/1"] = 1

            sv_table = rbind(sv_table, sv_local_table)
        }

        ###############################################
        # Part 10 - Plots
        ###############################################

        # prepare png
        png(
            filename = paste(sampleName, "_chr", chromosome,
                             ".png", sep = ""),
            bg = "white",
            width = pngWidth,
            height = pngHeight,
            units = "px",
            pointsize = 24
        )

        # plot all variants
        plot(
            positions,
            variation,
            cex = 0.2,
            pch = 16,
            col = "blue",
            cex.lab = 1,
            xlab = paste0("Chromosome_", chromosome),
            ylab = "Number of alternative reads / depth",
            ylim = c(0, 1),
            xlim = c(0, max(positions))
        )

        if (chromosome != "Y") {
            MA <- movingAverage(variation, MA_Window)
            lines(positions, MA, col = "red", lwd = 2)
        }
        abline(h = 0.75,
               lwd = 4,
               col = "red")
        abline(v = centromeres$Start[chromosomeIndex],
               lwd = 4,
               col = "orange")
        abline(v = centromeres$Stop[chromosomeIndex],
               lwd = 4,
               col = "orange")

        # plot nonsynonymous/frameshift/nonesene coding variants, simple, rare in dbsnp and exac
        points(
            final_positions,
            final_variations,
            cex = 3,
            pch = 16,
            col = "green"
        )

        if (!missing(sv_sample)) {
            # plot structural variants that passed the filter
            points(
                sv_local_table$start_position,
                variation_sv,
                cex = 3,
                pch = 16,
                col = "orange"
            )
        }

        dev.off()

    } # end chromosome loop

    final_table[final_table == ""] = NA
    final_table = final_table[-1,] # remove dummy first row
    final_table$Gene.names...primary.. <-
        NULL # remove duplicated column with gene name

    # write to output
    write.table(
        final_table,
        paste0("RareVariants_", sampleName, ".txt"),
        sep = "\t",
        row.names = FALSE,
        quote = FALSE
    )

    complex_table[complex_table == ""] = NA
    complex_table = complex_table[-1,] # remove dummy first row


    # write to output
    write.table(
        complex_table,
        paste0("ComplexVariants_", sampleName, ".txt"),
        sep = "\t",
        row.names = FALSE,
        quote = FALSE
    )


    if (!missing(sv_sample)) {
        sv_table[sv_table == ""] = NA
        sv_table = sv_table[-1,] # remove dummy first row
        sv_table$Gene.names...primary.. <-
            NULL # remove duplicated column with gene name

        write.table(
            sv_table,
            paste0("StructuralVariants_", sampleName, ".txt"),
            sep = "\t",
            row.names = FALSE,
            quote = FALSE
        )
    }
}

\documentclass[a4paper]{article}

\usepackage{listings}
\usepackage{indentfirst}
\usepackage{graphicx}

\title{RareVariantVis 2: R suite for analysis of rare variants in whole genome sequencing data.}
\author{Adam Gudy\'{s} and Tomasz Stokowy}

%\VignetteIndexEntry{RareVariantVis}
%\VignetteEngine{knitr::knitr}

\begin{document}

\maketitle

\section*{Introduction}

The search for causative genetic variants in rare diseases of presumed monogenic inheritance has been boosted by the implementation of whole genome sequencing(WGS). Analysis and visualisation of WGS data is demanding due to its size and complexity.
To aid this challenge, we have developed a WGS data analysis suite---RareVariantVis 2. This new, significantly extended implementation of RareVariantVis (Stokowy et al., Bioinformatics 2016) annotates, filters and visualises whole human genome in less than 30 minutes. Method accepts and integrates vcf files for single nucleotide, structural and copy number variants. Proposed method was successfully used to disclose causes of three rare monogenic disorders, including one non-coding variant.

This vignette was created to present how to efficiently visualize and interprete genomic variants in R. Package RareVariantVis aims to present genomic variants (especially rare ones) in a global, per chromosome way. Visualization is performed in two ways---standard that outputs png figures and interactive that uses JavaScript d3 package. Interactive visualization allows to analyze trio/family data, for example in search for causative variants in rare Mendelian diseases.

This vignette presents example of Genome in a Bottle---NA12878 sample (chromosome 19) which is analyzed in about one minute on laptop/desktop computer. Examples include reading of all chr19 variants, filtering, annotation, visualization and homozygous region calling.

\section*{Example}
The analysis is preceeded by loading neccessary packages.
<<mychunk1, cache=TRUE, eval=FALSE, hide=TRUE>>=
library(RareVariantVis)
library(DataRareVariantVis)
@
\noindent
After that, single nucleotide variants (SNV) and structural variants (SV) for NA12878 have to be loaded from \texttt{DataRareVariantVis} package. Directories of these files are stored in \texttt{sample} and \texttt{sv\_sample} variables.
<<mychunk2, cache=TRUE, eval=FALSE, hide=TRUE>>=
sample = system.file("extdata", "CoriellIndex_S1.vcf.gz",
    package = "DataRareVariantVis")
sv_sample = system.file("extdata", "CoriellIndex_S1.sv.vcf.gz",
    package = "DataRareVariantVis")
@
\noindent
The \texttt{RareVariantVis} package supports vcf files generated by speedseq and GATK variant callers. The discovery of rare variants in chromosome 19 is performed by executing the following command.
<<mychunk3, cache=TRUE, eval=FALSE, hide=TRUE>>=
chromosomeVis(sample=sample, sv_sample=sv_sample,
    chromosomes=c("19"))
@
\noindent
As a result, the package creates a set of files describing discovered rare variants:
\begin{itemize}
    \setlength{\itemsep}{0pt}%
    \setlength{\topsep}{0pt}
    \setlength{\partopsep}{0pt}
    \setlength{\parsep}{0pt}
    \setlength{\parskip}{0pt}
    \item \textit{RareVariants\_CoriellIndex\_S1.txt}---table with single nucleotide variants,
    \item \textit{ComplexVariants\_CoriellIndex\_S1.txt}---table with complex variants,
    \item \textit{StructuralVariants\_CoriellIndex\_S1.txt}---table with structural variants,
    \item \textit{CoriellIndex\_S1\_chr19.png}---per-chromosome variants visualisation.
\end{itemize}
\noindent
If more than one chromosome is to be processed, separate visualisation files are generated. All tables are tab-separated text files with rows corresponding to variants and columns describing their properties.

\subsection*{Single nucleotide variants}
This table contain variants with a single alternative allele. They are described by the following columns:
\begin{itemize}
    \setlength{\itemsep}{0pt}%
    \setlength{\topsep}{0pt}
    \setlength{\partopsep}{0pt}
    \setlength{\parsep}{0pt}
    \setlength{\parskip}{0pt}
    \item \textit{chromosome}---number of chromosome,
    \item \textit{final\_positions}---position in chromosome,
    \item \textit{variant\_type}---type of mutation: synonymous/nonsynonymous/nonsense,
    \item \textit{ref\_allele}---reference allele,
    \item \textit{alt\_allele}---alternative allele,
    \item \textit{final\_variations}---homozygosity (ratio of alternative allele to depth),
    \item \textit{conservation}---conservation index according to UCSC phastCons.
\end{itemize}
\noindent
Additional columns are filled only for variants localized in coding regions:
\begin{itemize}
    \setlength{\itemsep}{0pt}%
    \setlength{\topsep}{0pt}
    \setlength{\partopsep}{0pt}
    \setlength{\parsep}{0pt}
    \setlength{\parskip}{0pt}
    \item \textit{gene\_name}---primary name of gene according to UCSC Human Genome annotation,
    \item \textit{in\_exon}---flag indicating whether variant is in exon,
    \item \textit{Entry}---corresponding UniProt entry,
    \item \textit{Status}---protein status (UniProt),
    \item \textit{Protein.names}---names of the corresponsing proteins (UniProt),
    \item \textit{Gene.names}---all gene aliases (UniProt),
    \item \textit{Annotation}---
    \item \textit{Tissue.specificity}---tissue specificity (UniProt),
    \item \textit{Gene.ontology..biological.process}---description of biological process the gene is involved in and ontology identifier (UniProt),
    \item \textit{Involvement.in.disease}---known involvement in diseases (UniProt)
    \item \textit{Cross.reference..Orphanet}---
    \item \textit{PubMed.ID}---colon-separated list of related PubMed identifiers (UniProt).
\end{itemize}

\subsection*{Complex variants}
Variants with more than one alternative allele are referred to as complex. They are described by:
\begin{itemize}
    \setlength{\itemsep}{0pt}%
    \setlength{\topsep}{0pt}
    \setlength{\partopsep}{0pt}
    \setlength{\parsep}{0pt}
    \setlength{\parskip}{0pt}
    \item \textit{chromosome}---number of chromosome,
    \item \textit{start\_position}---starting position in the chromosome,
\end{itemize}
\noindent
If variant spans over coding regions, additional additional UniProt columns are filled analogously as for SNVs.


\subsection*{Structural variants}
The table with structural variants have following columns:
\begin{itemize}
 \setlength{\itemsep}{0pt}%
    \setlength{\topsep}{0pt}
    \setlength{\partopsep}{0pt}
    \setlength{\parsep}{0pt}
    \setlength{\parskip}{0pt}
    \item \textit{chromosome}---number of chromosome,
    \item \textit{start\_position}---starting position in the chromosome,
    \item \textit{ID}---optional variant identifier,
    \item \textit{REF}---reference allele,
    \item \textit{ALT}---alternative allele,
    \item \textit{QUAL}---Phred-scaled probability that a REF/ALT polymorphism exists at this site given sequencing data,
    \item \textit{SVTYPE}---variant type: DUP(duplication)/DEL(deletion),
    \item \textit{GT}---genotype: 0/1 (heterozygous) or 1/1 (homozygous)
    \item \textit{end\_position}---genotype
\end{itemize}
\noindent
If variant spans over coding regions, additional additional UniProt columns are filled analogously as in SNVs.

\subsection*{Per-chromosome visualisation}
For each analyzed chromosome, discovered variants are visualized. The example visualisation file for NA12878 chromosome 19 is presented in Figure~\ref{Figure:chromosome-vis}. Figure illustrates variants (blue dots) in their genomic coordinates ($X$ axis). Ratio of alternative reads and depth ($Y$ axis) gives information about type of variant: homozygous alternative (expected ratio 1) and heterozygous (expected ratio 0.5). Green dots represent rare variants that pass filters: coding/UTR, nonsynonymous variant with dbSNP frequency < 0.01 and ExAC frequency < 0.01. Orange vertical lines depict position of centromere. Orange dots depict structural and copy number variants that overlap with coding region and are of relatively good quality (QUAL > 0). Red curve illustrates moving average of alternative reads/depth ratio. High values of this curve (exceeding 0.75) can suggest potential homozygous/deleterious regions.
\begin{figure}[thp]
	\centering
	\includegraphics[width=\textwidth]{CoriellIndex_S1_chr19.png}
	\caption{The visualisation file for NA12878 sample, chromosome 19.}
	\label{Figure:chromosome-vis}
\end{figure}

\section*{Interactive visualisation}
In order to perform interactive visualisation of NA12878 rare SNVs, the following piece of code has to be executed:
<<mychunk4, cache=TRUE, eval=FALSE, hide=TRUE>>=
rareVariantVis("RareVariants_CoriellIndex_S1.txt",
               "RareVariants_CoriellIndex_S1.html",
               "CorielIndex")
@
It reads a file containing table of rare variants (obtained from \texttt{chromosomeVis} function) and provides an adequate visualization (Figure~\ref{Figure:interactive-vis}). Function outputs visualization html figure in the current working directory. Figure illustrates variants (dots) in their genomic coordinates ($X$ axis). Ratio of alternative reads and depth ($Y$ axis) gives information about type of variant: homozygous alternative (expected ratio 1) and heterozygous (expected ratio 0.5). Zooming the plot is also supported. Pointing on variants provides basic information about the variant---name of gene and the position on the chromosome. If variants from many chromosomes are present in the table, all chromosomes are added to the same html file.

\begin{figure}[thp]
	\centering
	\includegraphics[width=\textwidth]{interactive.png}
	\caption{Interactive visualisation file for NA12878 sample, chromosome 19.}
	\label{Figure:interactive-vis}
\end{figure}

\section*{Multiple sample visualisation}
Another feature of RareVariantVis2 package is the ability to perform visualisation of multiple samples. Let \textit{RareVariants\_CoriellIndex\_S1.txt} and \textit{RareVariants\_Coriell\_S2.txt} be variant tables from different geneomes. One can visualise their 19 chromosome variants simulateously by running:
<<mychunk5, cache=TRUE, eval=FALSE, hide=TRUE>>=
inputFiles = c("RareVariants_CoriellIndex_S1.txt",
               "RareVariants_Coriell_S2.txt")
sampleNames = c("CoriellIndex_S1", "Coriell_S2");
multipleVis(inputFiles, "CorielSamples.html", sampleNames, "19")
@
\noindent
\end{document}

\name{multipleVis}
\alias{multipleVis}

\title{
Interactive visualization of rare variants on the chromosome, applicable for multiple files
}
\description{
Reads files containing table of rare variants from one chromosome and provides adequate multiple sample visualization. Input files can be obtained from function chromosomeVis.
Function outputs visualization html figure. Figure depicts samples in subfigures. Subfigures illustrate variants (dots) in their genomic coordinates (x axis). Ratio of alternative reads and depth (y axis) gives information about type of variant: homozygous alternative (expected ratio 1) and heterozygous (expected ratio 0.5). Zoom to the figures is possible, by marking the region of interest with mouse left click. Right click induces zoom out and return to the original plot.
Pointing on variants provides basic information about the variant - gene name and position on chromosome.
}

\usage{
multipleVis(inputFiles, outputFile, sampleNames, chromosome)
}

\arguments{
    \item{inputFiles}{Vector of strings containing input file names.}
    \item{outputFile}{Output file name (string).}
    \item{sampleNames}{Vector of sample names (strings).}
    \item{chromosome}{Name of the chromosome to be analyzed (string).}

}

\value{
    \item{comp1}{function returns html visualization file for specified samples}
}

\author{
Adam Gudys and Tomasz Stokowy
}


\examples{
file1 = system.file("extdata", "RareVariants_CoriellIndex_S1.txt",
                    package = "RareVariantVis")
file2 = system.file("extdata", "RareVariants_Coriell_S2.txt",
                    package = "RareVariantVis")
inputFiles = c(file1, file2)
sampleNames = c("CoriellIndex_S1", "Coriell_S2");
multipleVis(inputFiles, "CorielSamples.html", sampleNames, "19")
}

\keyword{ ~visualization }
\keyword{ ~rare varaints }

\name{chromosomeVis}
\alias{chromosomeVis}

\title{
Visualization of all genomic variants on the chromosome
}
\description{
Reads files containing single nucleotide variants (SNV) and structural genomic variants(SV) - vcf.gz files generated by speedseq aligner and variant caller.
Function outputs visualization png figures. Figure illustrates variants (blue dots) in their genomic coordinates (x axis). Ratio of alternative reads and depth (y axis) gives information about type of variant: homozygous alternative (expected ratio 1) and heterozygous (expected ratio 0.5). Green dots represent rare variants that pass filters: coding/UTR, nonsynonymous variant with dbSNP frequency < 0.01 and ExAC frequency < 0.01. Orange vertical lines depict position of centromere. Orange dots depict structural and copy number variants that overlap with coding region and are relatively good quality (QUAL > 0).
Red curve illustrates moving average of alternative reads/depth ratio. High values of this curve (exceeding 0.75) can suggest potential homozygous/deleterious regions.
In addition, files containing table with rare SNV and SV variants only are generated. Tables include variants that passed filters specified above with annotations (uniprot, RefSeq and other). Function analyzes whole genome in about 30 minutes on a desktop computer.
}

\usage{
chromosomeVis(sample, sv_sample, dbSNP_file, Exac_file, chromosomes, pngWidth, pngHeight, caller, MA_Window, coding_regions_file, annotation_file, uniprot_file)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{sample}{A name of SNV sample file to be analyzed.}
    \item{sv_sample}{A name of additional SV sample file. If not specified, structural variants are discarded.}
    \item{dbSNP_file}{A file with SNPs database. If not specified, chromosome 19 dbSNP is used.}
    \item{Exac_file}{ExAC database file. If not specified, chromosome 19 ExAC is used. }
    \item{chromosomes}{A vector of strings indicating chromosomes to be analyzed.}
    \item{pngWidth}{A number indicating pixel width of output png files. Default is 1600.}
    \item{pngHeight}{A number indicating pixel height of output png files. Default is 1200.}
    \item{caller}{A string indicating vcf caller. Default is "speedseq", supports "GATK"}
    \item{MA_Window}{A number indicating window size for moving average function. Recommended value for genome is 2000, for exome is 20. Default is 1000.}
    \item{coding_regions_file}{A bed file indicating coding regions}
    \item{annotation_file}{Text file indicating positions of the genes (from UCSC)}
    \item{uniprot_file}{Text file indicating gene functions and related diseases (from Uniprot)}

}

\value{
    \item{comp1}{function plots static visualization of genomic variants on all chromosomes, annotates them, filters and reports output variants in tables}
}

\author{
Adam Gudys and Tomasz Stokowy
}

\examples{

# analyze chromosome 19 from example genome
sample = system.file("extdata", "CoriellIndex_S1_chr19_9-10_S1.vcf.recode.vcf.gz",
  package = "RareVariantVis")
sv_sample = system.file("extdata", "CoriellIndex_S1.sv.vcf.gz",
  package = "RareVariantVis")
chromosomeVis(sample=sample, sv_sample=sv_sample, chromosomes=c("19"))

# without sv data
# sample = system.file("extdata", "CoriellIndex_S1_chr19_9-10_S1.vcf.recode.vcf.gz",
#    package = "RareVariantVis")
# chromosomeVis(sample=sample, chromosomes=c("19"))

# analyze entire genome (use external full-genome dbSNP and ExAC)
# it takes approximately 30 mins on a desktop computer
# large example data  and all necessary hg19 references can be downloaded from:
# https://github.com/agudys/DataRareVariantVis
# dbSNP_file = "All_20160601.vcf.gz"
# Exac_file = "ExAC.r0.3.1.sites.vep.vcf.gz"
# chromosomeVis(sample=sample, sv_sample=sv_sample,
#     dbSNP_file=dbSNP_file, Exac_file=Exac_file,
#     chromosomes=c(as.character(1:22), "X", "Y"), MA_Window = 2000,
# coding_regions_file = "nexterarapidcapture_exome_targetedregions_v1.2.bed",
# annotation_file = "UCSC_hg19_refSeq_160702.txt",
# uniprot_file = "uniprot-all.txt")


}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~visualization }
\keyword{ ~varaints }

\name{rareVariantVis}
\alias{rareVariantVis}

\title{
Interactive visualization of rare variants on the chromosome
}
\description{
Reads file containing table of rare variants from one chromosome and provides adequate visualization. Input file can be obtained from function chromosomeVis.
Function outputs visualization html figure in current working directory. Figure illustrates variants (dots) in their genomic coordinates (x axis). Ratio of alternative reads and depth (y axis) gives information about type of variant: homozygous alternative (expected ratio 1) and heterozygous (expected ratio 0.5). Zoom to the figures is possible, by marking the region of interest with mouse left click. Right click induces zoom out and return to the original plot.
Pointing on variants provides basic information about the variant - gene name and position on chromosome.

}
\usage{
rareVariantVis(input, outputFile, sample, chromosomes, append)
}

\arguments{
    \item{input}{Name of the input file (string) containing the table with rare variants generated by chromosomeVis. It can also be the variable with the table itself.}
    \item{outputFile}{Name of the output file (string) with visualisation.}
    \item{sample}{Name of the sample (used only for entitling the charts).}
    \item{chromosomes}{Vector of chromosome names (strings) to be included in the visualisation (all chromosomes by default). Chromosomes included in the parameter but absent in the table are ommited.}
    \item{append}{Logical value indicating whether charts should be appended to the output file without destroying it (FALSE by default).}
}

\value{
    \item{comp1}{function returns html file with visualization of rare variants}
}

\author{
Adam Gudys and Tomasz Stokowy
}

\examples{
file = system.file("extdata", "RareVariants_CoriellIndex_S1.txt",
    package = "RareVariantVis")
rareVariantVis(input=file, "RareVariants_CoriellIndex_S1.html", "CorielIndex")
}

\keyword{ ~visualization }
\keyword{ ~rare varaints }

\name{getCrisprGuides}
\alias{getCrisprGuides}
\title{
Retrieve CRISPR/Cas9 guides.
}
\description{
Function checks whether a guideRNA can be found that overlaps given SNP. Returns
sequence of the guideRNA with the variant marked with the lowercase letters.
When multiple guideRNAs are possible for given SNP, guideRNA with the variant
closest to the PAM site is being selected.
}

\arguments{
  \item{df}{ A data frame, preferably out from chromosomeVis.}
  \item{genome}{A object of the BSGenome, by default
  BSgenome.Hsapiens.UCSC.hg19.}
  \item{gsize}{Prefered size of the guideRNA, by default, standard 23 is used.}
  \item{PAM}{Prefered Protospacer Adjecent Motif "PAM", short motif that has to
  be found on the 5' end of the guideRNA, by default, Cas9 is used "GG".}
  \item{PAM_rev}{Prefered Protospacer Adjecent Motif "PAM", short motif that has
  to be found on the reverse strand, by default, Cas9 is used "CC".
  This is checked only when no guideRNA is found on the forward strand.}
}

\value{
    \item{character vector}{Vector of guideRNAs, when no guideRNA was found
    for the forward strand, reverse strand is checked, when no guideRNA is found
    NA is returned.}
}

\author{
Kornel Labun
}

\examples{
file <- system.file("extdata", "RareVariants_CoriellIndex_S1.txt",
    package = "RareVariantVis")
df <- read.delim(file, stringsAsFactors = FALSE)
getCrisprGuides(df)
}

\keyword{ ~CRISPR/Cas9}

\name{callHomozygous}
\alias{callHomozygous}
\title{
Call homozygous regions from sequencing data
}
\description{
Function calls homozygous regions from whole genome sequencing data.
}
\usage{
callHomozygous(sample, chromosomes, caller = "speedseq", MA_Window = 1000, HMZ_length  = 100000, min_n_HMZ = 20)
}

\arguments{
  \item{sample}{A name of SNV sample file to be analyzed.}
  \item{chromosomes}{A vector of strings indicating chromosomes to be analyzed.}
  \item{caller}{A string indicating vcf caller. Default is "speedseq", supports "GATK"}
    \item{MA_Window}{A number indicating window size for moving average function. Recommended value for genome is 2000, for exome is 20. Default is 1000.}
  \item{HMZ_length}{Minimal length of homozygous region to be called. Default is 100000.}
  \item{min_n_HMZ}{Minimal number of variants necessary to call a region. Default is 20.}
}

\value{
    \item{comp1}{function calls homozygous regions from whole genome sequencing data and returns them in a tab separated txt file.}
}

\author{
Tomasz Stokowy
}

\examples{
# sample = system.file("extdata", "CoriellIndex_S1_chr19_9-10_S1.vcf.recode.vcf.gz",
#                      package = "RareVariantVis")
# callHomozygous(sample=sample, chromosomes=c("19"))
}

\keyword{ ~call homozygous regions }

\name{movingAverage}
\alias{movingAverage}

\title{
Computation of moving average
}
\description{
Function calculates moving average from a vector of numeric values.
}
\usage{
movingAverage(x, n, centered)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{x}{a vector of numeric values for which moving average is computed}
    \item{n}{numeric value giving the frame length for moving average}
    \item{centered}{logic variable indicating if moving average should be centered (default = FALSE)}
}

\value{
    \item{comp1}{function returns vector of moving average values}
}

\author{
Winston Chang
}

\examples{
movingAverage(1:20, n=3, centered=FALSE)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~moving average }
